=== debian/control ===
Source: ros-melodic-fmi-adapter
Section: misc
Priority: optional
Maintainer: Ralph Lange <ralph.lange@de.bosch.com>
Build-Depends: debhelper (>= 9.0.0), git, ros-melodic-catkin, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-std-msgs
Homepage: http://wiki.ros.org/fmi_adapter
Standards-Version: 3.9.2

Package: ros-melodic-fmi-adapter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-roscpp, ros-melodic-std-msgs
Description: Wraps FMUs for co-simulation
